// ВНИМАНИЕ Сгенерировано автоматом из файла MicItem.yml
// ВНИМАНИЕ Не менять руками!

import AELog
import BusX
import Combine
import Foundation
import MPAKX
import UIKit

// MARK: - Context

public protocol MicItemContext {
  var activityDates: MPAK.Recent<Date?> { get }
  var timeout: Bool { get }
}

extension MicItem {

  // MARK: - Model

  public struct Model: MicItemContext {
    public var activityDates: MPAK.Recent<Date?> = .init(nil)
    public var timeout: Bool = false
  }

  // MARK: - Controller

  final class Controller: MPAK.Controller<MicItem.Model> {
    init(_ id: String? = nil) {
      var sid = ""
      if let id {
        sid = " : \(id)"
      }
      super.init(
        MicItem.Model(),
        debugClassName: "MicItemCtrl",
        debugLog: { aelog("\($0)\(sid)") }
      )

      // Отправляем модель в Шину.
      m
        .sink { v in Bus.send(Bus.keyId("MicItem", id), v) }
        .store(in: &subscriptions)

      pipeValue(
        dbg: "activityD",
        Bus.events.compactMap { Bus.convertKeyValue(Bus.keyId(K.activityDates, id), $0) }.map { (k: String, v: Date?) in v }.eraseToAnyPublisher(),
        {
          $0.activityDates.value = $1
          $0.activityDates.isRecent = true
        },
        { m, _ in m.activityDates.isRecent = false }
      )
      pipe(
        dbg: "timeout",
        Bus.events.compactMap { Bus.convertKeyValue(Bus.keyId(K.timeout, id), $0) }.map { (k: String, v: Bool) in v }.eraseToAnyPublisher(),
        { $0.timeout = true },
        { $0.timeout = false }
      )

    }
  }
}
